
#include "snake.h"
#include "ili9320.h"
#include <stdlib.h>

uint16_t SnakeLength = 0;
uint16_t GameStep = 0;
uint8_t  Seed[2] = {0,0};


SnakeNode* Snake_Intialize(SnakeNode *head)
{
  head = CreatSnake(head, 30, 14); //ʼͷλ
	head = CreatSnake(head, 30, 15); //ʼλ
	head = CreatSnake(head, 30, 16); //ʼλ
	head = CreatSnake(head, 30, 17); //ʼβλ

	SnakeOutput(head, SnakeColor);   //ʼ
	return head;
}

/****************************************************************************
*     ƣSnakeNode *CreatSnake(SnakeNode *head, SNAKEX x, SNAKEY y)
*     ܣ
* ڲheadͷָ x λλ yλڵλ
* ڲheadͷָ
* ˵    
* ÷SSnakeHead = SnakeMove(SnakeHead);
*     ߣzc
****************************************************************************/
SnakeNode *CreatSnake(SnakeNode *head, SNAKEX x, SNAKEY y)
{
  SnakeNode *p;
	p = (SnakeNode*)malloc(LEN);
	
	p->snake_x = x;
	p->snake_y = y;
	
	//ǳʼ壬ƶĬ£ʵΪ
	if(0 == GameStep)
	{
	  p->snake_move_now = down;
	}
	
	//½ͷλãpֵhead
	if(0 == SnakeLength)
	{
		head = p;
		head->snake_move_next = head->snake_move_now;
		p = p->next;
	}
	
	//½Ĳͷ
	else
	{
		SnakeNode *p1 = head;
		uint8_t i;
		
		for (i=0; i<SnakeLength-1; i++)
		{
			p1 = p1->next;
		}
		p->snake_move_next = p1 ->snake_move_now;
	  
		//ӵ壬Ϊβ
		if(GameStep != 0)
		{
			
			//ߵβĵֵƶ״̬ȷɵβλ
			if(p1->snake_move_now == up)
			{
				p->snake_x = p1->snake_x;
        p->snake_y = p1->snake_y - 1;			
			}
			if(p1->snake_move_now == down)
			{
				p->snake_x = p1->snake_x;
        p->snake_y = p1->snake_y + 1;		
			}
			if(p1->snake_move_now == left)
			{
				p->snake_x = p1->snake_x - 1;
        p->snake_y = p1->snake_y;	
			}
			if(p1->snake_move_now == right)
			{
				p->snake_x = p1->snake_x + 1;
        p->snake_y = p1->snake_y;
			}
			
			//ɵβĵǰƶ״̬ԭβĵǰƶ״̬һ
			p->snake_move_now = p1 ->snake_move_now;
			
			//ɵβֱʾ
			GUI_Line(10+BodyX*(p->snake_x - 1),10+BodyY*(p->snake_y - 1),
		  15+BodyX*(p->snake_x - 1),15+BodyY*(p->snake_y - 1),SnakeColor);
		}
		
		p1->next = p;
		p = p->next;
		p1 = p;
		free(p1);
	}
	
	SnakeLength++; //ߵ峤1
	return head;
};

/****************************************************************************
*     ƣvvoid SnakeOutput(SnakeNode *head, unsigned short color)
*     ܣTFT
* ڲheadͷָ  color ߵɫ
* ڲ
* ˵    Ϊȫ嶼TFTϣ֮ȥβͷƶ
* ÷SSnakeOutput
*     ߣzc
****************************************************************************/
void SnakeOutput(SnakeNode *head, unsigned short color)
{
	uint8_t i;
	SnakeNode *p2 = head;
	
	//ߵԱķʽ
	if(0 == GameStep)
	{
	  for (i=0; i<SnakeLength; i++)
	  {
		  GUI_Line(10+BodyX*(p2->snake_x - 1),10+BodyY*(p2->snake_y - 1),
		  15+BodyX*(p2->snake_x - 1),15+BodyY*(p2->snake_y - 1),color);
	    p2 = p2->next;
	  }
	}
	else
	{
		for (i=0; i<SnakeLength-1; i++)
	  {
	        p2 = p2->next;
	  }
		
		/*ƶ֮ǰȥβ*/
		if(color == Green)
		{		 
			 GUI_Line(10+BodyX*(p2->snake_x - 1),10+BodyY*(p2->snake_y - 1),
		        15+BodyX*(p2->snake_x - 1),15+BodyY*(p2->snake_y - 1),color);
		}
		
		/*ƶͷ*/
		if(color == SnakeColor)
		{
			GUI_Line(10+BodyX*(head->snake_x - 1),10+BodyY*(head->snake_y - 1),
		        15+BodyX*(head->snake_x - 1),15+BodyY*(head->snake_y - 1),color);
		}
		p2 = p2->next;
	}
	p2 = NULL;
	free(p2);
}

/****************************************************************************
*     ƣSnakeNode *SnakeMove(SnakeNode *head)
*     ܣƶ
* ڲheadͷָ
* ڲheadͷָ
* ˵    ƶÿεøݵǰÿλлƶһλ
* ÷SSnakeHead = SnakeMove(SnakeHead);
*     ߣzc
****************************************************************************/
SnakeNode *SnakeMove(SnakeNode *head)
{
  uint8_t i;
	
	//u16 BackColor;
	
	SnakeNode *p = head; //ָָͷ
	
	for (i=0; i<SnakeLength-1; i++)
	{
		p->next->snake_move_next = p->snake_move_now; //ĳһλ״̬һλһ״̬λ
		p = p->next;
  }

	GameStep++;  //Ϸ1
	SnakeOutput(head, Green);

	p = head;	
	//ƶ
	for (i=0; i<SnakeLength; i++)
	{
		switch (p->snake_move_now)
		{
			case up:
				  (p->snake_y)++;
			     break;
			case down:
				  (p->snake_y)--;
			     break;
			case right:
				  (p->snake_x)--;
			     break;
			case left:
				  (p->snake_x)++;
			     break;
			default:
				   break;
		}
		p->snake_move_now = p->snake_move_next;
		p = p->next;
  }
	p = NULL;
	free(p);
	
//	BackColor = ili9320_GetPoint(head-> snake_x, head->snake_y);

//	//Ϸش
//	if (BackColor == Black)
//	{
//	  //Ϸ
//		while(1);
//	}
	
  SnakeOutput(head, SnakeColor);//ƶTFT
	
	//Եһ
	if ((Seed[0] == head ->snake_x) && (Seed[1] == head->snake_y))
	{
		head = CreatSnake(head, Seed[0], Seed[1]); //βSeed[0]seed[1]Ч
		CreateSeed(head);
	}
	
	return(head);
}

/****************************************************************************
*     ƣCreateSeed(void)
*     ܣ
* ڲheadͷָ
* ڲ
* ˵    systickʱӲαΪⲿжϣӳʼܲ
* ÷CreateSeed(SnakeHead);
*     ߣzc
****************************************************************************/
void CreateSeed(SnakeNode *head)
{
	SnakeNode *p = head;
	uint8_t flag = 0; //ȷǷ
	
	while(1)
	{
		unsigned char i =0;
		
		//ϵͳδαΪҪ󲻸߿˴
		Seed[0] = (SysTick->VAL)%FrameX;
		Seed[0]++;
		Seed[1] = (SysTick->VAL)%FrameY;
		Seed[1]++;
		
		//壬ֵͬʾӲϣ²
		for(i = 0; i<SnakeLength; i++)
		{
			if((Seed[0] == p->snake_x) && (Seed[1] == p->snake_y))
		  {
			   flag = 1;
				 break;
		  }
			p = p->next;
		}
		
		if(0 == flag)
		{
			break;
		}
		flag = 0;
	}
	
	free(p);
	
	//뵽Ļϵָλ
	GUI_Line(10+BodyX*(Seed[0] - 1),10+BodyY*(Seed[1] - 1),
		         15+BodyX*(Seed[0] - 1),15+BodyY*(Seed[1] - 1),Blue);
}
