#include "malloc.h"

//ھ̬洢Ͻ˹
 __align(4) u8 membase[MEM_MAX_SIZE];   //4ֽڶʵڴ 1*8*1024B = 8KB

u16 memmapbase[MEM_ALLOC_TABLE_SIZE];   //ڴռ2*256B = 0.5KB  
  
const u32 memtblsize = MEM_ALLOC_TABLE_SIZE;    //ڴ                         
const u32 memblksize = MEM_BLOCK_SIZE;          //ڴ鳤                     
const u32 memsize = MEM_MAX_SIZE;               //ڴ              

/*************************************************
struct _m_mallco_dev
 {
  void (*init)(void);  //ʼ   
  u8 (*perused)(void); //ڴʹ     
  u8  *membasex;       //ڴأڴ  
  u16 *memmapx;        //ڴ״̬
  u8  memrdyx;         //ڴǷ
};
***************************************************/
struct _m_mallco_dev mallco_dev=
 {
  mem_init,     //void *mem_init(void) ָָ룬൱ڵ
  mem_perused,  //u8 *mem_perused(void)	 
  membase,      //ڴصַ  ָָ    
  memmapbase,   //ڴ״̬           
  0,            //ڴǷ
};


void mymemcpy(void *des,const void *src,u32 n)  //ڴ
{  
  u8 *xdes=des;               //ָĿڴָ                                       
  const u8 *xsrc=src;         //ָԴַָ
  while(n--)*xdes++=*xsrc++;  //ԴڴַڵݸƸĿĵַ
}  

void mymemset(void *s,u8 c,u32 count)  //ڴжӦλֵ
{  
   u8 *xs = s;  
   while(count--)*xs++=c;  
}    

void mem_init()  //ڴڴسʼλ0
{  
  mymemset(mallco_dev.memmapx, 0, memtblsize*2);    //ڴֵֵΪ0ջ4ֽڶģҪڴ*2      
  mymemset(mallco_dev.membasex, 0, memsize);        //ڴصֵֵΪ0ڴ4ֽڵģڴڴسȼ     
  mallco_dev.memrdyx=1;                             //ڴ
}  

u8 mem_perused(void)  //ڴʹ
{  
  u32 used=0;  
  u32 i;  
  for(i=0;i<memtblsize;i++)  
  {  
     if(mallco_dev.memmapx[i])used++;            //⵽ڴλʹʱʹֵ+1
  } 
  return (used*100)/(memtblsize);                
}  

 
u32 mem_malloc(u32 size)  //ڴ(ڲ)
{  
  signed long offset=0;  
  u16 nmemb;   //ҪڴĿ
  u16 cmemb=0; //ѡڴĿ
  u32 i;  
	
  if(!mallco_dev.memrdyx)
	{
		mallco_dev.init();        //ڴδʼ
	}
	
  if(size == 0)
	{
      return 0XFFFFFFFF;     //ڴΪ0򷵻ش
  }           

  nmemb=size/memblksize;     //ҪڴĿȡֵ
	if(size%memblksize)nmemb++;//ֵҪڴĿ1
  
  for(offset=memtblsize-1; offset>=0; offset--)    
  {     
		/*********************************
		ڴڴӦλֵΪ0
		ʾδʹãѡĿ+1,һ
		ʹõĿʱcmemb<nmemb,ѡ
		0¿ʼ
		***********************************/
    if(!mallco_dev.memmapx[offset]) 
		{
			cmemb++;
		}			
    else
		{
			cmemb=0;
		}
		
		//ѡĿҪĿ飬ڴӦλñʶ
    if(cmemb==nmemb)       
    {
      for(i=0;i<nmemb;i++)       
      {  
         mallco_dev.memmapx[offset+i]=nmemb;  
      }  
      return (offset*memblksize);//ڴڴе׵ַ          
    }
  }  
  return 0XFFFFFFFF; 
}  
 
u8 mem_free(u32 offset)  
{  
  int i;  
	
	//ڴδʼ
  if(!mallco_dev.memrdyx)
  {
    mallco_dev.init();    
    return 1;
  }  
	
	//ͷŵڴ淶ΧСڴ򣬱ʾͷŵڴڴ
  if(offset < memsize)                               
  {  
    int index=offset/memblksize;           //ҪͷŵڴĿ 
    int nmemb=mallco_dev.memmapx[index];   //øڴӦڴ׵ַеֵ
    for(i=0;i<nmemb;i++)                   //ڴӦڴȫ0ʾʹ
    {  
        mallco_dev.memmapx[index+i]=0;  
    }  
    return 0;  
  }
	else return 2;  
}  

void myfree(void *ptr)  
{  
  u32 offset;  
  if(ptr == NULL)
	{
		return;  //ָ룬Ҫͷ
	}		
  offset=(u32)ptr-(u32)mallco_dev.membasex;  //øڴռڴ
	
  mem_free(offset);                          //ͷڴ
}  

 
void *mymalloc(u32 size)  
{  
  u32 offset;  
	
  offset=mem_malloc(size);          //ڴ棬ڴе׵ַ
	
  if(offset==0XFFFFFFFF)
	{
		return NULL;
	}		
  else 
	{
		return (void*)((u32)mallco_dev.membasex+offset);  //ڴ棬ڴе׵ַ
	}
}  

 
void *myrealloc(void *ptr,u32 size)  //·ʼַΪptrԼsizeΧڵĵַ
{  
  u32 offset;  
  offset=mem_malloc(size);           
  if(offset==0XFFFFFFFF)
	{
		return NULL; 
	}    
  else  
  {              
    mymemcpy((void*)((u32)mallco_dev.membasex+offset),ptr,size);      
    myfree(ptr);                     
    return (void*)((u32)mallco_dev.membasex+offset);         
  }  
} 
